import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2RouteResponseConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html#api_id Apigatewayv2RouteResponse#api_id}.
     *
     * @stability stable
     */
    readonly apiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html#model_selection_expression Apigatewayv2RouteResponse#model_selection_expression}.
     *
     * @stability stable
     */
    readonly modelSelectionExpression?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html#response_models Apigatewayv2RouteResponse#response_models}.
     *
     * @stability stable
     */
    readonly responseModels?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html#route_id Apigatewayv2RouteResponse#route_id}.
     *
     * @stability stable
     */
    readonly routeId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html#route_response_key Apigatewayv2RouteResponse#route_response_key}.
     *
     * @stability stable
     */
    readonly routeResponseKey: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html aws_apigatewayv2_route_response}.
 *
 * @stability stable
 */
export declare class Apigatewayv2RouteResponse extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html aws_apigatewayv2_route_response} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2RouteResponseConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _modelSelectionExpression?;
    /**
     * @stability stable
     */
    get modelSelectionExpression(): string;
    /**
     * @stability stable
     */
    set modelSelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetModelSelectionExpression(): void;
    /**
     * @stability stable
     */
    get modelSelectionExpressionInput(): string | undefined;
    private _responseModels?;
    /**
     * @stability stable
     */
    get responseModels(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set responseModels(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetResponseModels(): void;
    /**
     * @stability stable
     */
    get responseModelsInput(): {
        [key: string]: string;
    } | undefined;
    private _routeId;
    /**
     * @stability stable
     */
    get routeId(): string;
    /**
     * @stability stable
     */
    set routeId(value: string);
    /**
     * @stability stable
     */
    get routeIdInput(): string;
    private _routeResponseKey;
    /**
     * @stability stable
     */
    get routeResponseKey(): string;
    /**
     * @stability stable
     */
    set routeResponseKey(value: string);
    /**
     * @stability stable
     */
    get routeResponseKeyInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
