import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudfrontDistributionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#aliases CloudfrontDistribution#aliases}.
     *
     * @stability stable
     */
    readonly aliases?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#comment CloudfrontDistribution#comment}.
     *
     * @stability stable
     */
    readonly comment?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#default_root_object CloudfrontDistribution#default_root_object}.
     *
     * @stability stable
     */
    readonly defaultRootObject?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#enabled CloudfrontDistribution#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#http_version CloudfrontDistribution#http_version}.
     *
     * @stability stable
     */
    readonly httpVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#is_ipv6_enabled CloudfrontDistribution#is_ipv6_enabled}.
     *
     * @stability stable
     */
    readonly isIpv6Enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#price_class CloudfrontDistribution#price_class}.
     *
     * @stability stable
     */
    readonly priceClass?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#retain_on_delete CloudfrontDistribution#retain_on_delete}.
     *
     * @stability stable
     */
    readonly retainOnDelete?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#tags CloudfrontDistribution#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#tags_all CloudfrontDistribution#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#wait_for_deployment CloudfrontDistribution#wait_for_deployment}.
     *
     * @stability stable
     */
    readonly waitForDeployment?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#web_acl_id CloudfrontDistribution#web_acl_id}.
     *
     * @stability stable
     */
    readonly webAclId?: string;
    /**
     * custom_error_response block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#custom_error_response CloudfrontDistribution#custom_error_response}
     *
     * @stability stable
     */
    readonly customErrorResponse?: CloudfrontDistributionCustomErrorResponse[];
    /**
     * default_cache_behavior block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#default_cache_behavior CloudfrontDistribution#default_cache_behavior}
     *
     * @stability stable
     */
    readonly defaultCacheBehavior: CloudfrontDistributionDefaultCacheBehavior[];
    /**
     * logging_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#logging_config CloudfrontDistribution#logging_config}
     *
     * @stability stable
     */
    readonly loggingConfig?: CloudfrontDistributionLoggingConfig[];
    /**
     * ordered_cache_behavior block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#ordered_cache_behavior CloudfrontDistribution#ordered_cache_behavior}
     *
     * @stability stable
     */
    readonly orderedCacheBehavior?: CloudfrontDistributionOrderedCacheBehavior[];
    /**
     * origin block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin CloudfrontDistribution#origin}
     *
     * @stability stable
     */
    readonly origin: CloudfrontDistributionOrigin[];
    /**
     * origin_group block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_group CloudfrontDistribution#origin_group}
     *
     * @stability stable
     */
    readonly originGroup?: CloudfrontDistributionOriginGroup[];
    /**
     * restrictions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#restrictions CloudfrontDistribution#restrictions}
     *
     * @stability stable
     */
    readonly restrictions: CloudfrontDistributionRestrictions[];
    /**
     * viewer_certificate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#viewer_certificate CloudfrontDistribution#viewer_certificate}
     *
     * @stability stable
     */
    readonly viewerCertificate: CloudfrontDistributionViewerCertificate[];
}
/**
 * @stability stable
 */
export declare class CloudfrontDistributionTrustedKeyGroupsItems extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get keyGroupId(): string;
    /**
     * @stability stable
     */
    get keyPairIds(): string[];
}
/**
 * @stability stable
 */
export declare class CloudfrontDistributionTrustedKeyGroups extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get items(): any;
}
/**
 * @stability stable
 */
export declare class CloudfrontDistributionTrustedSignersItems extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get awsAccountNumber(): string;
    /**
     * @stability stable
     */
    get keyPairIds(): string[];
}
/**
 * @stability stable
 */
export declare class CloudfrontDistributionTrustedSigners extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get items(): any;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionCustomErrorResponse {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#error_caching_min_ttl CloudfrontDistribution#error_caching_min_ttl}.
     *
     * @stability stable
     */
    readonly errorCachingMinTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#error_code CloudfrontDistribution#error_code}.
     *
     * @stability stable
     */
    readonly errorCode: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#response_code CloudfrontDistribution#response_code}.
     *
     * @stability stable
     */
    readonly responseCode?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#response_page_path CloudfrontDistribution#response_page_path}.
     *
     * @stability stable
     */
    readonly responsePagePath?: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionDefaultCacheBehaviorForwardedValuesCookies {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#forward CloudfrontDistribution#forward}.
     *
     * @stability stable
     */
    readonly forward: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#whitelisted_names CloudfrontDistribution#whitelisted_names}.
     *
     * @stability stable
     */
    readonly whitelistedNames?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionDefaultCacheBehaviorForwardedValues {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#headers CloudfrontDistribution#headers}.
     *
     * @stability stable
     */
    readonly headers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#query_string CloudfrontDistribution#query_string}.
     *
     * @stability stable
     */
    readonly queryString: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#query_string_cache_keys CloudfrontDistribution#query_string_cache_keys}.
     *
     * @stability stable
     */
    readonly queryStringCacheKeys?: string[];
    /**
     * cookies block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cookies CloudfrontDistribution#cookies}
     *
     * @stability stable
     */
    readonly cookies: CloudfrontDistributionDefaultCacheBehaviorForwardedValuesCookies[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionDefaultCacheBehaviorFunctionAssociation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#event_type CloudfrontDistribution#event_type}.
     *
     * @stability stable
     */
    readonly eventType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#function_arn CloudfrontDistribution#function_arn}.
     *
     * @stability stable
     */
    readonly functionArn: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionDefaultCacheBehaviorLambdaFunctionAssociation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#event_type CloudfrontDistribution#event_type}.
     *
     * @stability stable
     */
    readonly eventType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#include_body CloudfrontDistribution#include_body}.
     *
     * @stability stable
     */
    readonly includeBody?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#lambda_arn CloudfrontDistribution#lambda_arn}.
     *
     * @stability stable
     */
    readonly lambdaArn: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionDefaultCacheBehavior {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#allowed_methods CloudfrontDistribution#allowed_methods}.
     *
     * @stability stable
     */
    readonly allowedMethods: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cache_policy_id CloudfrontDistribution#cache_policy_id}.
     *
     * @stability stable
     */
    readonly cachePolicyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cached_methods CloudfrontDistribution#cached_methods}.
     *
     * @stability stable
     */
    readonly cachedMethods: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#compress CloudfrontDistribution#compress}.
     *
     * @stability stable
     */
    readonly compress?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#default_ttl CloudfrontDistribution#default_ttl}.
     *
     * @stability stable
     */
    readonly defaultTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#field_level_encryption_id CloudfrontDistribution#field_level_encryption_id}.
     *
     * @stability stable
     */
    readonly fieldLevelEncryptionId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#max_ttl CloudfrontDistribution#max_ttl}.
     *
     * @stability stable
     */
    readonly maxTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#min_ttl CloudfrontDistribution#min_ttl}.
     *
     * @stability stable
     */
    readonly minTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_request_policy_id CloudfrontDistribution#origin_request_policy_id}.
     *
     * @stability stable
     */
    readonly originRequestPolicyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#realtime_log_config_arn CloudfrontDistribution#realtime_log_config_arn}.
     *
     * @stability stable
     */
    readonly realtimeLogConfigArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#smooth_streaming CloudfrontDistribution#smooth_streaming}.
     *
     * @stability stable
     */
    readonly smoothStreaming?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#target_origin_id CloudfrontDistribution#target_origin_id}.
     *
     * @stability stable
     */
    readonly targetOriginId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#trusted_key_groups CloudfrontDistribution#trusted_key_groups}.
     *
     * @stability stable
     */
    readonly trustedKeyGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#trusted_signers CloudfrontDistribution#trusted_signers}.
     *
     * @stability stable
     */
    readonly trustedSigners?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#viewer_protocol_policy CloudfrontDistribution#viewer_protocol_policy}.
     *
     * @stability stable
     */
    readonly viewerProtocolPolicy: string;
    /**
     * forwarded_values block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#forwarded_values CloudfrontDistribution#forwarded_values}
     *
     * @stability stable
     */
    readonly forwardedValues?: CloudfrontDistributionDefaultCacheBehaviorForwardedValues[];
    /**
     * function_association block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#function_association CloudfrontDistribution#function_association}
     *
     * @stability stable
     */
    readonly functionAssociation?: CloudfrontDistributionDefaultCacheBehaviorFunctionAssociation[];
    /**
     * lambda_function_association block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#lambda_function_association CloudfrontDistribution#lambda_function_association}
     *
     * @stability stable
     */
    readonly lambdaFunctionAssociation?: CloudfrontDistributionDefaultCacheBehaviorLambdaFunctionAssociation[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionLoggingConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#bucket CloudfrontDistribution#bucket}.
     *
     * @stability stable
     */
    readonly bucket: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#include_cookies CloudfrontDistribution#include_cookies}.
     *
     * @stability stable
     */
    readonly includeCookies?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#prefix CloudfrontDistribution#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOrderedCacheBehaviorForwardedValuesCookies {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#forward CloudfrontDistribution#forward}.
     *
     * @stability stable
     */
    readonly forward: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#whitelisted_names CloudfrontDistribution#whitelisted_names}.
     *
     * @stability stable
     */
    readonly whitelistedNames?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOrderedCacheBehaviorForwardedValues {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#headers CloudfrontDistribution#headers}.
     *
     * @stability stable
     */
    readonly headers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#query_string CloudfrontDistribution#query_string}.
     *
     * @stability stable
     */
    readonly queryString: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#query_string_cache_keys CloudfrontDistribution#query_string_cache_keys}.
     *
     * @stability stable
     */
    readonly queryStringCacheKeys?: string[];
    /**
     * cookies block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cookies CloudfrontDistribution#cookies}
     *
     * @stability stable
     */
    readonly cookies: CloudfrontDistributionOrderedCacheBehaviorForwardedValuesCookies[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOrderedCacheBehaviorFunctionAssociation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#event_type CloudfrontDistribution#event_type}.
     *
     * @stability stable
     */
    readonly eventType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#function_arn CloudfrontDistribution#function_arn}.
     *
     * @stability stable
     */
    readonly functionArn: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOrderedCacheBehaviorLambdaFunctionAssociation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#event_type CloudfrontDistribution#event_type}.
     *
     * @stability stable
     */
    readonly eventType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#include_body CloudfrontDistribution#include_body}.
     *
     * @stability stable
     */
    readonly includeBody?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#lambda_arn CloudfrontDistribution#lambda_arn}.
     *
     * @stability stable
     */
    readonly lambdaArn: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOrderedCacheBehavior {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#allowed_methods CloudfrontDistribution#allowed_methods}.
     *
     * @stability stable
     */
    readonly allowedMethods: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cache_policy_id CloudfrontDistribution#cache_policy_id}.
     *
     * @stability stable
     */
    readonly cachePolicyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cached_methods CloudfrontDistribution#cached_methods}.
     *
     * @stability stable
     */
    readonly cachedMethods: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#compress CloudfrontDistribution#compress}.
     *
     * @stability stable
     */
    readonly compress?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#default_ttl CloudfrontDistribution#default_ttl}.
     *
     * @stability stable
     */
    readonly defaultTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#field_level_encryption_id CloudfrontDistribution#field_level_encryption_id}.
     *
     * @stability stable
     */
    readonly fieldLevelEncryptionId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#max_ttl CloudfrontDistribution#max_ttl}.
     *
     * @stability stable
     */
    readonly maxTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#min_ttl CloudfrontDistribution#min_ttl}.
     *
     * @stability stable
     */
    readonly minTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_request_policy_id CloudfrontDistribution#origin_request_policy_id}.
     *
     * @stability stable
     */
    readonly originRequestPolicyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#path_pattern CloudfrontDistribution#path_pattern}.
     *
     * @stability stable
     */
    readonly pathPattern: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#realtime_log_config_arn CloudfrontDistribution#realtime_log_config_arn}.
     *
     * @stability stable
     */
    readonly realtimeLogConfigArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#smooth_streaming CloudfrontDistribution#smooth_streaming}.
     *
     * @stability stable
     */
    readonly smoothStreaming?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#target_origin_id CloudfrontDistribution#target_origin_id}.
     *
     * @stability stable
     */
    readonly targetOriginId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#trusted_key_groups CloudfrontDistribution#trusted_key_groups}.
     *
     * @stability stable
     */
    readonly trustedKeyGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#trusted_signers CloudfrontDistribution#trusted_signers}.
     *
     * @stability stable
     */
    readonly trustedSigners?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#viewer_protocol_policy CloudfrontDistribution#viewer_protocol_policy}.
     *
     * @stability stable
     */
    readonly viewerProtocolPolicy: string;
    /**
     * forwarded_values block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#forwarded_values CloudfrontDistribution#forwarded_values}
     *
     * @stability stable
     */
    readonly forwardedValues?: CloudfrontDistributionOrderedCacheBehaviorForwardedValues[];
    /**
     * function_association block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#function_association CloudfrontDistribution#function_association}
     *
     * @stability stable
     */
    readonly functionAssociation?: CloudfrontDistributionOrderedCacheBehaviorFunctionAssociation[];
    /**
     * lambda_function_association block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#lambda_function_association CloudfrontDistribution#lambda_function_association}
     *
     * @stability stable
     */
    readonly lambdaFunctionAssociation?: CloudfrontDistributionOrderedCacheBehaviorLambdaFunctionAssociation[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginCustomHeader {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#name CloudfrontDistribution#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#value CloudfrontDistribution#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginCustomOriginConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#http_port CloudfrontDistribution#http_port}.
     *
     * @stability stable
     */
    readonly httpPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#https_port CloudfrontDistribution#https_port}.
     *
     * @stability stable
     */
    readonly httpsPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_keepalive_timeout CloudfrontDistribution#origin_keepalive_timeout}.
     *
     * @stability stable
     */
    readonly originKeepaliveTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_protocol_policy CloudfrontDistribution#origin_protocol_policy}.
     *
     * @stability stable
     */
    readonly originProtocolPolicy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_read_timeout CloudfrontDistribution#origin_read_timeout}.
     *
     * @stability stable
     */
    readonly originReadTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_ssl_protocols CloudfrontDistribution#origin_ssl_protocols}.
     *
     * @stability stable
     */
    readonly originSslProtocols: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginOriginShield {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#enabled CloudfrontDistribution#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_shield_region CloudfrontDistribution#origin_shield_region}.
     *
     * @stability stable
     */
    readonly originShieldRegion: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginS3OriginConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_access_identity CloudfrontDistribution#origin_access_identity}.
     *
     * @stability stable
     */
    readonly originAccessIdentity: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOrigin {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#connection_attempts CloudfrontDistribution#connection_attempts}.
     *
     * @stability stable
     */
    readonly connectionAttempts?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#connection_timeout CloudfrontDistribution#connection_timeout}.
     *
     * @stability stable
     */
    readonly connectionTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#domain_name CloudfrontDistribution#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_id CloudfrontDistribution#origin_id}.
     *
     * @stability stable
     */
    readonly originId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_path CloudfrontDistribution#origin_path}.
     *
     * @stability stable
     */
    readonly originPath?: string;
    /**
     * custom_header block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#custom_header CloudfrontDistribution#custom_header}
     *
     * @stability stable
     */
    readonly customHeader?: CloudfrontDistributionOriginCustomHeader[];
    /**
     * custom_origin_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#custom_origin_config CloudfrontDistribution#custom_origin_config}
     *
     * @stability stable
     */
    readonly customOriginConfig?: CloudfrontDistributionOriginCustomOriginConfig[];
    /**
     * origin_shield block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_shield CloudfrontDistribution#origin_shield}
     *
     * @stability stable
     */
    readonly originShield?: CloudfrontDistributionOriginOriginShield[];
    /**
     * s3_origin_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#s3_origin_config CloudfrontDistribution#s3_origin_config}
     *
     * @stability stable
     */
    readonly s3OriginConfig?: CloudfrontDistributionOriginS3OriginConfig[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginGroupFailoverCriteria {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#status_codes CloudfrontDistribution#status_codes}.
     *
     * @stability stable
     */
    readonly statusCodes: number[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginGroupMember {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_id CloudfrontDistribution#origin_id}.
     *
     * @stability stable
     */
    readonly originId: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginGroup {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_id CloudfrontDistribution#origin_id}.
     *
     * @stability stable
     */
    readonly originId: string;
    /**
     * failover_criteria block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#failover_criteria CloudfrontDistribution#failover_criteria}
     *
     * @stability stable
     */
    readonly failoverCriteria: CloudfrontDistributionOriginGroupFailoverCriteria[];
    /**
     * member block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#member CloudfrontDistribution#member}
     *
     * @stability stable
     */
    readonly member: CloudfrontDistributionOriginGroupMember[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionRestrictionsGeoRestriction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#locations CloudfrontDistribution#locations}.
     *
     * @stability stable
     */
    readonly locations?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#restriction_type CloudfrontDistribution#restriction_type}.
     *
     * @stability stable
     */
    readonly restrictionType: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionRestrictions {
    /**
     * geo_restriction block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#geo_restriction CloudfrontDistribution#geo_restriction}
     *
     * @stability stable
     */
    readonly geoRestriction: CloudfrontDistributionRestrictionsGeoRestriction[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionViewerCertificate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#acm_certificate_arn CloudfrontDistribution#acm_certificate_arn}.
     *
     * @stability stable
     */
    readonly acmCertificateArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cloudfront_default_certificate CloudfrontDistribution#cloudfront_default_certificate}.
     *
     * @stability stable
     */
    readonly cloudfrontDefaultCertificate?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#iam_certificate_id CloudfrontDistribution#iam_certificate_id}.
     *
     * @stability stable
     */
    readonly iamCertificateId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#minimum_protocol_version CloudfrontDistribution#minimum_protocol_version}.
     *
     * @stability stable
     */
    readonly minimumProtocolVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#ssl_support_method CloudfrontDistribution#ssl_support_method}.
     *
     * @stability stable
     */
    readonly sslSupportMethod?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html aws_cloudfront_distribution}.
 *
 * @stability stable
 */
export declare class CloudfrontDistribution extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html aws_cloudfront_distribution} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudfrontDistributionConfig);
    private _aliases?;
    /**
     * @stability stable
     */
    get aliases(): string[];
    /**
     * @stability stable
     */
    set aliases(value: string[]);
    /**
     * @stability stable
     */
    resetAliases(): void;
    /**
     * @stability stable
     */
    get aliasesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get callerReference(): string;
    private _comment?;
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    set comment(value: string);
    /**
     * @stability stable
     */
    resetComment(): void;
    /**
     * @stability stable
     */
    get commentInput(): string | undefined;
    private _defaultRootObject?;
    /**
     * @stability stable
     */
    get defaultRootObject(): string;
    /**
     * @stability stable
     */
    set defaultRootObject(value: string);
    /**
     * @stability stable
     */
    resetDefaultRootObject(): void;
    /**
     * @stability stable
     */
    get defaultRootObjectInput(): string | undefined;
    /**
     * @stability stable
     */
    get domainName(): string;
    private _enabled;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    get enabledInput(): boolean;
    /**
     * @stability stable
     */
    get etag(): string;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
    private _httpVersion?;
    /**
     * @stability stable
     */
    get httpVersion(): string;
    /**
     * @stability stable
     */
    set httpVersion(value: string);
    /**
     * @stability stable
     */
    resetHttpVersion(): void;
    /**
     * @stability stable
     */
    get httpVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get inProgressValidationBatches(): number;
    private _isIpv6Enabled?;
    /**
     * @stability stable
     */
    get isIpv6Enabled(): boolean;
    /**
     * @stability stable
     */
    set isIpv6Enabled(value: boolean);
    /**
     * @stability stable
     */
    resetIsIpv6Enabled(): void;
    /**
     * @stability stable
     */
    get isIpv6EnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get lastModifiedTime(): string;
    private _priceClass?;
    /**
     * @stability stable
     */
    get priceClass(): string;
    /**
     * @stability stable
     */
    set priceClass(value: string);
    /**
     * @stability stable
     */
    resetPriceClass(): void;
    /**
     * @stability stable
     */
    get priceClassInput(): string | undefined;
    private _retainOnDelete?;
    /**
     * @stability stable
     */
    get retainOnDelete(): boolean;
    /**
     * @stability stable
     */
    set retainOnDelete(value: boolean);
    /**
     * @stability stable
     */
    resetRetainOnDelete(): void;
    /**
     * @stability stable
     */
    get retainOnDeleteInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    trustedKeyGroups(index: string): CloudfrontDistributionTrustedKeyGroups;
    /**
     * @stability stable
     */
    trustedSigners(index: string): CloudfrontDistributionTrustedSigners;
    private _waitForDeployment?;
    /**
     * @stability stable
     */
    get waitForDeployment(): boolean;
    /**
     * @stability stable
     */
    set waitForDeployment(value: boolean);
    /**
     * @stability stable
     */
    resetWaitForDeployment(): void;
    /**
     * @stability stable
     */
    get waitForDeploymentInput(): boolean | undefined;
    private _webAclId?;
    /**
     * @stability stable
     */
    get webAclId(): string;
    /**
     * @stability stable
     */
    set webAclId(value: string);
    /**
     * @stability stable
     */
    resetWebAclId(): void;
    /**
     * @stability stable
     */
    get webAclIdInput(): string | undefined;
    private _customErrorResponse?;
    /**
     * @stability stable
     */
    get customErrorResponse(): CloudfrontDistributionCustomErrorResponse[];
    /**
     * @stability stable
     */
    set customErrorResponse(value: CloudfrontDistributionCustomErrorResponse[]);
    /**
     * @stability stable
     */
    resetCustomErrorResponse(): void;
    /**
     * @stability stable
     */
    get customErrorResponseInput(): CloudfrontDistributionCustomErrorResponse[] | undefined;
    private _defaultCacheBehavior;
    /**
     * @stability stable
     */
    get defaultCacheBehavior(): CloudfrontDistributionDefaultCacheBehavior[];
    /**
     * @stability stable
     */
    set defaultCacheBehavior(value: CloudfrontDistributionDefaultCacheBehavior[]);
    /**
     * @stability stable
     */
    get defaultCacheBehaviorInput(): CloudfrontDistributionDefaultCacheBehavior[];
    private _loggingConfig?;
    /**
     * @stability stable
     */
    get loggingConfig(): CloudfrontDistributionLoggingConfig[];
    /**
     * @stability stable
     */
    set loggingConfig(value: CloudfrontDistributionLoggingConfig[]);
    /**
     * @stability stable
     */
    resetLoggingConfig(): void;
    /**
     * @stability stable
     */
    get loggingConfigInput(): CloudfrontDistributionLoggingConfig[] | undefined;
    private _orderedCacheBehavior?;
    /**
     * @stability stable
     */
    get orderedCacheBehavior(): CloudfrontDistributionOrderedCacheBehavior[];
    /**
     * @stability stable
     */
    set orderedCacheBehavior(value: CloudfrontDistributionOrderedCacheBehavior[]);
    /**
     * @stability stable
     */
    resetOrderedCacheBehavior(): void;
    /**
     * @stability stable
     */
    get orderedCacheBehaviorInput(): CloudfrontDistributionOrderedCacheBehavior[] | undefined;
    private _origin;
    /**
     * @stability stable
     */
    get origin(): CloudfrontDistributionOrigin[];
    /**
     * @stability stable
     */
    set origin(value: CloudfrontDistributionOrigin[]);
    /**
     * @stability stable
     */
    get originInput(): CloudfrontDistributionOrigin[];
    private _originGroup?;
    /**
     * @stability stable
     */
    get originGroup(): CloudfrontDistributionOriginGroup[];
    /**
     * @stability stable
     */
    set originGroup(value: CloudfrontDistributionOriginGroup[]);
    /**
     * @stability stable
     */
    resetOriginGroup(): void;
    /**
     * @stability stable
     */
    get originGroupInput(): CloudfrontDistributionOriginGroup[] | undefined;
    private _restrictions;
    /**
     * @stability stable
     */
    get restrictions(): CloudfrontDistributionRestrictions[];
    /**
     * @stability stable
     */
    set restrictions(value: CloudfrontDistributionRestrictions[]);
    /**
     * @stability stable
     */
    get restrictionsInput(): CloudfrontDistributionRestrictions[];
    private _viewerCertificate;
    /**
     * @stability stable
     */
    get viewerCertificate(): CloudfrontDistributionViewerCertificate[];
    /**
     * @stability stable
     */
    set viewerCertificate(value: CloudfrontDistributionViewerCertificate[]);
    /**
     * @stability stable
     */
    get viewerCertificateInput(): CloudfrontDistributionViewerCertificate[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
