import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CognitoIdentityProviderConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_provider.html#attribute_mapping CognitoIdentityProvider#attribute_mapping}.
     *
     * @stability stable
     */
    readonly attributeMapping?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_provider.html#idp_identifiers CognitoIdentityProvider#idp_identifiers}.
     *
     * @stability stable
     */
    readonly idpIdentifiers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_provider.html#provider_details CognitoIdentityProvider#provider_details}.
     *
     * @stability stable
     */
    readonly providerDetails: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_provider.html#provider_name CognitoIdentityProvider#provider_name}.
     *
     * @stability stable
     */
    readonly providerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_provider.html#provider_type CognitoIdentityProvider#provider_type}.
     *
     * @stability stable
     */
    readonly providerType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_provider.html#user_pool_id CognitoIdentityProvider#user_pool_id}.
     *
     * @stability stable
     */
    readonly userPoolId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_provider.html aws_cognito_identity_provider}.
 *
 * @stability stable
 */
export declare class CognitoIdentityProvider extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_provider.html aws_cognito_identity_provider} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CognitoIdentityProviderConfig);
    private _attributeMapping?;
    /**
     * @stability stable
     */
    get attributeMapping(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set attributeMapping(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetAttributeMapping(): void;
    /**
     * @stability stable
     */
    get attributeMappingInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _idpIdentifiers?;
    /**
     * @stability stable
     */
    get idpIdentifiers(): string[];
    /**
     * @stability stable
     */
    set idpIdentifiers(value: string[]);
    /**
     * @stability stable
     */
    resetIdpIdentifiers(): void;
    /**
     * @stability stable
     */
    get idpIdentifiersInput(): string[] | undefined;
    private _providerDetails;
    /**
     * @stability stable
     */
    get providerDetails(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set providerDetails(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    get providerDetailsInput(): {
        [key: string]: string;
    };
    private _providerName;
    /**
     * @stability stable
     */
    get providerName(): string;
    /**
     * @stability stable
     */
    set providerName(value: string);
    /**
     * @stability stable
     */
    get providerNameInput(): string;
    private _providerType;
    /**
     * @stability stable
     */
    get providerType(): string;
    /**
     * @stability stable
     */
    set providerType(value: string);
    /**
     * @stability stable
     */
    get providerTypeInput(): string;
    private _userPoolId;
    /**
     * @stability stable
     */
    get userPoolId(): string;
    /**
     * @stability stable
     */
    set userPoolId(value: string);
    /**
     * @stability stable
     */
    get userPoolIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
