import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsIdentitystoreGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/identitystore_group.html#group_id DataAwsIdentitystoreGroup#group_id}.
     *
     * @stability stable
     */
    readonly groupId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/identitystore_group.html#identity_store_id DataAwsIdentitystoreGroup#identity_store_id}.
     *
     * @stability stable
     */
    readonly identityStoreId: string;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/identitystore_group.html#filter DataAwsIdentitystoreGroup#filter}
     *
     * @stability stable
     */
    readonly filter: DataAwsIdentitystoreGroupFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsIdentitystoreGroupFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/identitystore_group.html#attribute_path DataAwsIdentitystoreGroup#attribute_path}.
     *
     * @stability stable
     */
    readonly attributePath: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/identitystore_group.html#attribute_value DataAwsIdentitystoreGroup#attribute_value}.
     *
     * @stability stable
     */
    readonly attributeValue: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/identitystore_group.html aws_identitystore_group}.
 *
 * @stability stable
 */
export declare class DataAwsIdentitystoreGroup extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/identitystore_group.html aws_identitystore_group} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsIdentitystoreGroupConfig);
    /**
     * @stability stable
     */
    get displayName(): string;
    private _groupId?;
    /**
     * @stability stable
     */
    get groupId(): string;
    /**
     * @stability stable
     */
    set groupId(value: string);
    /**
     * @stability stable
     */
    resetGroupId(): void;
    /**
     * @stability stable
     */
    get groupIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _identityStoreId;
    /**
     * @stability stable
     */
    get identityStoreId(): string;
    /**
     * @stability stable
     */
    set identityStoreId(value: string);
    /**
     * @stability stable
     */
    get identityStoreIdInput(): string;
    private _filter;
    /**
     * @stability stable
     */
    get filter(): DataAwsIdentitystoreGroupFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsIdentitystoreGroupFilter[]);
    /**
     * @stability stable
     */
    get filterInput(): DataAwsIdentitystoreGroupFilter[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
