import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsIdentitystoreUserConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/identitystore_user.html#identity_store_id DataAwsIdentitystoreUser#identity_store_id}.
     *
     * @stability stable
     */
    readonly identityStoreId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/identitystore_user.html#user_id DataAwsIdentitystoreUser#user_id}.
     *
     * @stability stable
     */
    readonly userId?: string;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/identitystore_user.html#filter DataAwsIdentitystoreUser#filter}
     *
     * @stability stable
     */
    readonly filter: DataAwsIdentitystoreUserFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsIdentitystoreUserFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/identitystore_user.html#attribute_path DataAwsIdentitystoreUser#attribute_path}.
     *
     * @stability stable
     */
    readonly attributePath: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/identitystore_user.html#attribute_value DataAwsIdentitystoreUser#attribute_value}.
     *
     * @stability stable
     */
    readonly attributeValue: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/identitystore_user.html aws_identitystore_user}.
 *
 * @stability stable
 */
export declare class DataAwsIdentitystoreUser extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/identitystore_user.html aws_identitystore_user} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsIdentitystoreUserConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _identityStoreId;
    /**
     * @stability stable
     */
    get identityStoreId(): string;
    /**
     * @stability stable
     */
    set identityStoreId(value: string);
    /**
     * @stability stable
     */
    get identityStoreIdInput(): string;
    private _userId?;
    /**
     * @stability stable
     */
    get userId(): string;
    /**
     * @stability stable
     */
    set userId(value: string);
    /**
     * @stability stable
     */
    resetUserId(): void;
    /**
     * @stability stable
     */
    get userIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get userName(): string;
    private _filter;
    /**
     * @stability stable
     */
    get filter(): DataAwsIdentitystoreUserFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsIdentitystoreUserFilter[]);
    /**
     * @stability stable
     */
    get filterInput(): DataAwsIdentitystoreUserFilter[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
