import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsResourcegroupstaggingapiResourcesConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#exclude_compliant_resources DataAwsResourcegroupstaggingapiResources#exclude_compliant_resources}.
     *
     * @stability stable
     */
    readonly excludeCompliantResources?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#include_compliance_details DataAwsResourcegroupstaggingapiResources#include_compliance_details}.
     *
     * @stability stable
     */
    readonly includeComplianceDetails?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#resource_arn_list DataAwsResourcegroupstaggingapiResources#resource_arn_list}.
     *
     * @stability stable
     */
    readonly resourceArnList?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#resource_type_filters DataAwsResourcegroupstaggingapiResources#resource_type_filters}.
     *
     * @stability stable
     */
    readonly resourceTypeFilters?: string[];
    /**
     * tag_filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#tag_filter DataAwsResourcegroupstaggingapiResources#tag_filter}
     *
     * @stability stable
     */
    readonly tagFilter?: DataAwsResourcegroupstaggingapiResourcesTagFilter[];
}
/**
 * @stability stable
 */
export declare class DataAwsResourcegroupstaggingapiResourcesResourceTagMappingListComplianceDetails extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get complianceStatus(): boolean;
    /**
     * @stability stable
     */
    get keysWithNoncompliantValues(): string[];
    /**
     * @stability stable
     */
    get nonCompliantKeys(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsResourcegroupstaggingapiResourcesResourceTagMappingList extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get complianceDetails(): any;
    /**
     * @stability stable
     */
    get resourceArn(): string;
    /**
     * @stability stable
     */
    get tags(): any;
}
/**
 * @stability stable
 */
export interface DataAwsResourcegroupstaggingapiResourcesTagFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#key DataAwsResourcegroupstaggingapiResources#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#values DataAwsResourcegroupstaggingapiResources#values}.
     *
     * @stability stable
     */
    readonly values?: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html aws_resourcegroupstaggingapi_resources}.
 *
 * @stability stable
 */
export declare class DataAwsResourcegroupstaggingapiResources extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html aws_resourcegroupstaggingapi_resources} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsResourcegroupstaggingapiResourcesConfig);
    private _excludeCompliantResources?;
    /**
     * @stability stable
     */
    get excludeCompliantResources(): boolean;
    /**
     * @stability stable
     */
    set excludeCompliantResources(value: boolean);
    /**
     * @stability stable
     */
    resetExcludeCompliantResources(): void;
    /**
     * @stability stable
     */
    get excludeCompliantResourcesInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _includeComplianceDetails?;
    /**
     * @stability stable
     */
    get includeComplianceDetails(): boolean;
    /**
     * @stability stable
     */
    set includeComplianceDetails(value: boolean);
    /**
     * @stability stable
     */
    resetIncludeComplianceDetails(): void;
    /**
     * @stability stable
     */
    get includeComplianceDetailsInput(): boolean | undefined;
    private _resourceArnList?;
    /**
     * @stability stable
     */
    get resourceArnList(): string[];
    /**
     * @stability stable
     */
    set resourceArnList(value: string[]);
    /**
     * @stability stable
     */
    resetResourceArnList(): void;
    /**
     * @stability stable
     */
    get resourceArnListInput(): string[] | undefined;
    /**
     * @stability stable
     */
    resourceTagMappingList(index: string): DataAwsResourcegroupstaggingapiResourcesResourceTagMappingList;
    private _resourceTypeFilters?;
    /**
     * @stability stable
     */
    get resourceTypeFilters(): string[];
    /**
     * @stability stable
     */
    set resourceTypeFilters(value: string[]);
    /**
     * @stability stable
     */
    resetResourceTypeFilters(): void;
    /**
     * @stability stable
     */
    get resourceTypeFiltersInput(): string[] | undefined;
    private _tagFilter?;
    /**
     * @stability stable
     */
    get tagFilter(): DataAwsResourcegroupstaggingapiResourcesTagFilter[];
    /**
     * @stability stable
     */
    set tagFilter(value: DataAwsResourcegroupstaggingapiResourcesTagFilter[]);
    /**
     * @stability stable
     */
    resetTagFilter(): void;
    /**
     * @stability stable
     */
    get tagFilterInput(): DataAwsResourcegroupstaggingapiResourcesTagFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
