import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DatasyncTaskConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#cloudwatch_log_group_arn DatasyncTask#cloudwatch_log_group_arn}.
     *
     * @stability stable
     */
    readonly cloudwatchLogGroupArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#destination_location_arn DatasyncTask#destination_location_arn}.
     *
     * @stability stable
     */
    readonly destinationLocationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#name DatasyncTask#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#source_location_arn DatasyncTask#source_location_arn}.
     *
     * @stability stable
     */
    readonly sourceLocationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#tags DatasyncTask#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#tags_all DatasyncTask#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * excludes block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#excludes DatasyncTask#excludes}
     *
     * @stability stable
     */
    readonly excludes?: DatasyncTaskExcludes[];
    /**
     * options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#options DatasyncTask#options}
     *
     * @stability stable
     */
    readonly options?: DatasyncTaskOptions[];
    /**
     * schedule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#schedule DatasyncTask#schedule}
     *
     * @stability stable
     */
    readonly schedule?: DatasyncTaskSchedule[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#timeouts DatasyncTask#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DatasyncTaskTimeouts;
}
/**
 * @stability stable
 */
export interface DatasyncTaskExcludes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#filter_type DatasyncTask#filter_type}.
     *
     * @stability stable
     */
    readonly filterType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#value DatasyncTask#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface DatasyncTaskOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#atime DatasyncTask#atime}.
     *
     * @stability stable
     */
    readonly atime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#bytes_per_second DatasyncTask#bytes_per_second}.
     *
     * @stability stable
     */
    readonly bytesPerSecond?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#gid DatasyncTask#gid}.
     *
     * @stability stable
     */
    readonly gid?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#log_level DatasyncTask#log_level}.
     *
     * @stability stable
     */
    readonly logLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#mtime DatasyncTask#mtime}.
     *
     * @stability stable
     */
    readonly mtime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#overwrite_mode DatasyncTask#overwrite_mode}.
     *
     * @stability stable
     */
    readonly overwriteMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#posix_permissions DatasyncTask#posix_permissions}.
     *
     * @stability stable
     */
    readonly posixPermissions?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#preserve_deleted_files DatasyncTask#preserve_deleted_files}.
     *
     * @stability stable
     */
    readonly preserveDeletedFiles?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#preserve_devices DatasyncTask#preserve_devices}.
     *
     * @stability stable
     */
    readonly preserveDevices?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#task_queueing DatasyncTask#task_queueing}.
     *
     * @stability stable
     */
    readonly taskQueueing?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#transfer_mode DatasyncTask#transfer_mode}.
     *
     * @stability stable
     */
    readonly transferMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#uid DatasyncTask#uid}.
     *
     * @stability stable
     */
    readonly uid?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#verify_mode DatasyncTask#verify_mode}.
     *
     * @stability stable
     */
    readonly verifyMode?: string;
}
/**
 * @stability stable
 */
export interface DatasyncTaskSchedule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#schedule_expression DatasyncTask#schedule_expression}.
     *
     * @stability stable
     */
    readonly scheduleExpression: string;
}
/**
 * @stability stable
 */
export interface DatasyncTaskTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#create DatasyncTask#create}.
     *
     * @stability stable
     */
    readonly create?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html aws_datasync_task}.
 *
 * @stability stable
 */
export declare class DatasyncTask extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html aws_datasync_task} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DatasyncTaskConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _cloudwatchLogGroupArn?;
    /**
     * @stability stable
     */
    get cloudwatchLogGroupArn(): string;
    /**
     * @stability stable
     */
    set cloudwatchLogGroupArn(value: string);
    /**
     * @stability stable
     */
    resetCloudwatchLogGroupArn(): void;
    /**
     * @stability stable
     */
    get cloudwatchLogGroupArnInput(): string | undefined;
    private _destinationLocationArn;
    /**
     * @stability stable
     */
    get destinationLocationArn(): string;
    /**
     * @stability stable
     */
    set destinationLocationArn(value: string);
    /**
     * @stability stable
     */
    get destinationLocationArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _sourceLocationArn;
    /**
     * @stability stable
     */
    get sourceLocationArn(): string;
    /**
     * @stability stable
     */
    set sourceLocationArn(value: string);
    /**
     * @stability stable
     */
    get sourceLocationArnInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _excludes?;
    /**
     * @stability stable
     */
    get excludes(): DatasyncTaskExcludes[];
    /**
     * @stability stable
     */
    set excludes(value: DatasyncTaskExcludes[]);
    /**
     * @stability stable
     */
    resetExcludes(): void;
    /**
     * @stability stable
     */
    get excludesInput(): DatasyncTaskExcludes[] | undefined;
    private _options?;
    /**
     * @stability stable
     */
    get options(): DatasyncTaskOptions[];
    /**
     * @stability stable
     */
    set options(value: DatasyncTaskOptions[]);
    /**
     * @stability stable
     */
    resetOptions(): void;
    /**
     * @stability stable
     */
    get optionsInput(): DatasyncTaskOptions[] | undefined;
    private _schedule?;
    /**
     * @stability stable
     */
    get schedule(): DatasyncTaskSchedule[];
    /**
     * @stability stable
     */
    set schedule(value: DatasyncTaskSchedule[]);
    /**
     * @stability stable
     */
    resetSchedule(): void;
    /**
     * @stability stable
     */
    get scheduleInput(): DatasyncTaskSchedule[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DatasyncTaskTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DatasyncTaskTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DatasyncTaskTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
