import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DxGatewayAssociationProposalConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association_proposal.html#allowed_prefixes DxGatewayAssociationProposal#allowed_prefixes}.
     *
     * @stability stable
     */
    readonly allowedPrefixes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association_proposal.html#associated_gateway_id DxGatewayAssociationProposal#associated_gateway_id}.
     *
     * @stability stable
     */
    readonly associatedGatewayId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association_proposal.html#dx_gateway_id DxGatewayAssociationProposal#dx_gateway_id}.
     *
     * @stability stable
     */
    readonly dxGatewayId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association_proposal.html#dx_gateway_owner_account_id DxGatewayAssociationProposal#dx_gateway_owner_account_id}.
     *
     * @stability stable
     */
    readonly dxGatewayOwnerAccountId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association_proposal.html aws_dx_gateway_association_proposal}.
 *
 * @stability stable
 */
export declare class DxGatewayAssociationProposal extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association_proposal.html aws_dx_gateway_association_proposal} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DxGatewayAssociationProposalConfig);
    private _allowedPrefixes?;
    /**
     * @stability stable
     */
    get allowedPrefixes(): string[];
    /**
     * @stability stable
     */
    set allowedPrefixes(value: string[]);
    /**
     * @stability stable
     */
    resetAllowedPrefixes(): void;
    /**
     * @stability stable
     */
    get allowedPrefixesInput(): string[] | undefined;
    private _associatedGatewayId;
    /**
     * @stability stable
     */
    get associatedGatewayId(): string;
    /**
     * @stability stable
     */
    set associatedGatewayId(value: string);
    /**
     * @stability stable
     */
    get associatedGatewayIdInput(): string;
    /**
     * @stability stable
     */
    get associatedGatewayOwnerAccountId(): string;
    /**
     * @stability stable
     */
    get associatedGatewayType(): string;
    private _dxGatewayId;
    /**
     * @stability stable
     */
    get dxGatewayId(): string;
    /**
     * @stability stable
     */
    set dxGatewayId(value: string);
    /**
     * @stability stable
     */
    get dxGatewayIdInput(): string;
    private _dxGatewayOwnerAccountId;
    /**
     * @stability stable
     */
    get dxGatewayOwnerAccountId(): string;
    /**
     * @stability stable
     */
    set dxGatewayOwnerAccountId(value: string);
    /**
     * @stability stable
     */
    get dxGatewayOwnerAccountIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
