import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2ClientVpnEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#client_cidr_block Ec2ClientVpnEndpoint#client_cidr_block}.
     *
     * @stability stable
     */
    readonly clientCidrBlock: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#description Ec2ClientVpnEndpoint#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#dns_servers Ec2ClientVpnEndpoint#dns_servers}.
     *
     * @stability stable
     */
    readonly dnsServers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#server_certificate_arn Ec2ClientVpnEndpoint#server_certificate_arn}.
     *
     * @stability stable
     */
    readonly serverCertificateArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#split_tunnel Ec2ClientVpnEndpoint#split_tunnel}.
     *
     * @stability stable
     */
    readonly splitTunnel?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#tags Ec2ClientVpnEndpoint#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#tags_all Ec2ClientVpnEndpoint#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#transport_protocol Ec2ClientVpnEndpoint#transport_protocol}.
     *
     * @stability stable
     */
    readonly transportProtocol?: string;
    /**
     * authentication_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#authentication_options Ec2ClientVpnEndpoint#authentication_options}
     *
     * @stability stable
     */
    readonly authenticationOptions: Ec2ClientVpnEndpointAuthenticationOptions[];
    /**
     * connection_log_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#connection_log_options Ec2ClientVpnEndpoint#connection_log_options}
     *
     * @stability stable
     */
    readonly connectionLogOptions: Ec2ClientVpnEndpointConnectionLogOptions[];
}
/**
 * @stability stable
 */
export interface Ec2ClientVpnEndpointAuthenticationOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#active_directory_id Ec2ClientVpnEndpoint#active_directory_id}.
     *
     * @stability stable
     */
    readonly activeDirectoryId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#root_certificate_chain_arn Ec2ClientVpnEndpoint#root_certificate_chain_arn}.
     *
     * @stability stable
     */
    readonly rootCertificateChainArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#saml_provider_arn Ec2ClientVpnEndpoint#saml_provider_arn}.
     *
     * @stability stable
     */
    readonly samlProviderArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#type Ec2ClientVpnEndpoint#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface Ec2ClientVpnEndpointConnectionLogOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#cloudwatch_log_group Ec2ClientVpnEndpoint#cloudwatch_log_group}.
     *
     * @stability stable
     */
    readonly cloudwatchLogGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#cloudwatch_log_stream Ec2ClientVpnEndpoint#cloudwatch_log_stream}.
     *
     * @stability stable
     */
    readonly cloudwatchLogStream?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#enabled Ec2ClientVpnEndpoint#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html aws_ec2_client_vpn_endpoint}.
 *
 * @stability stable
 */
export declare class Ec2ClientVpnEndpoint extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html aws_ec2_client_vpn_endpoint} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2ClientVpnEndpointConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _clientCidrBlock;
    /**
     * @stability stable
     */
    get clientCidrBlock(): string;
    /**
     * @stability stable
     */
    set clientCidrBlock(value: string);
    /**
     * @stability stable
     */
    get clientCidrBlockInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    private _dnsServers?;
    /**
     * @stability stable
     */
    get dnsServers(): string[];
    /**
     * @stability stable
     */
    set dnsServers(value: string[]);
    /**
     * @stability stable
     */
    resetDnsServers(): void;
    /**
     * @stability stable
     */
    get dnsServersInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _serverCertificateArn;
    /**
     * @stability stable
     */
    get serverCertificateArn(): string;
    /**
     * @stability stable
     */
    set serverCertificateArn(value: string);
    /**
     * @stability stable
     */
    get serverCertificateArnInput(): string;
    private _splitTunnel?;
    /**
     * @stability stable
     */
    get splitTunnel(): boolean;
    /**
     * @stability stable
     */
    set splitTunnel(value: boolean);
    /**
     * @stability stable
     */
    resetSplitTunnel(): void;
    /**
     * @stability stable
     */
    get splitTunnelInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _transportProtocol?;
    /**
     * @stability stable
     */
    get transportProtocol(): string;
    /**
     * @stability stable
     */
    set transportProtocol(value: string);
    /**
     * @stability stable
     */
    resetTransportProtocol(): void;
    /**
     * @stability stable
     */
    get transportProtocolInput(): string | undefined;
    private _authenticationOptions;
    /**
     * @stability stable
     */
    get authenticationOptions(): Ec2ClientVpnEndpointAuthenticationOptions[];
    /**
     * @stability stable
     */
    set authenticationOptions(value: Ec2ClientVpnEndpointAuthenticationOptions[]);
    /**
     * @stability stable
     */
    get authenticationOptionsInput(): Ec2ClientVpnEndpointAuthenticationOptions[];
    private _connectionLogOptions;
    /**
     * @stability stable
     */
    get connectionLogOptions(): Ec2ClientVpnEndpointConnectionLogOptions[];
    /**
     * @stability stable
     */
    set connectionLogOptions(value: Ec2ClientVpnEndpointConnectionLogOptions[]);
    /**
     * @stability stable
     */
    get connectionLogOptionsInput(): Ec2ClientVpnEndpointConnectionLogOptions[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
