import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ElasticacheGlobalReplicationGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_global_replication_group.html#global_replication_group_description ElasticacheGlobalReplicationGroup#global_replication_group_description}.
     *
     * @stability stable
     */
    readonly globalReplicationGroupDescription?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_global_replication_group.html#global_replication_group_id_suffix ElasticacheGlobalReplicationGroup#global_replication_group_id_suffix}.
     *
     * @stability stable
     */
    readonly globalReplicationGroupIdSuffix: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_global_replication_group.html#primary_replication_group_id ElasticacheGlobalReplicationGroup#primary_replication_group_id}.
     *
     * @stability stable
     */
    readonly primaryReplicationGroupId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elasticache_global_replication_group.html aws_elasticache_global_replication_group}.
 *
 * @stability stable
 */
export declare class ElasticacheGlobalReplicationGroup extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elasticache_global_replication_group.html aws_elasticache_global_replication_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElasticacheGlobalReplicationGroupConfig);
    /**
     * @stability stable
     */
    get actualEngineVersion(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get atRestEncryptionEnabled(): boolean;
    /**
     * @stability stable
     */
    get authTokenEnabled(): boolean;
    /**
     * @stability stable
     */
    get cacheNodeType(): string;
    /**
     * @stability stable
     */
    get clusterEnabled(): boolean;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    get engineVersionActual(): string;
    private _globalReplicationGroupDescription?;
    /**
     * @stability stable
     */
    get globalReplicationGroupDescription(): string;
    /**
     * @stability stable
     */
    set globalReplicationGroupDescription(value: string);
    /**
     * @stability stable
     */
    resetGlobalReplicationGroupDescription(): void;
    /**
     * @stability stable
     */
    get globalReplicationGroupDescriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get globalReplicationGroupId(): string;
    private _globalReplicationGroupIdSuffix;
    /**
     * @stability stable
     */
    get globalReplicationGroupIdSuffix(): string;
    /**
     * @stability stable
     */
    set globalReplicationGroupIdSuffix(value: string);
    /**
     * @stability stable
     */
    get globalReplicationGroupIdSuffixInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _primaryReplicationGroupId;
    /**
     * @stability stable
     */
    get primaryReplicationGroupId(): string;
    /**
     * @stability stable
     */
    set primaryReplicationGroupId(value: string);
    /**
     * @stability stable
     */
    get primaryReplicationGroupIdInput(): string;
    /**
     * @stability stable
     */
    get transitEncryptionEnabled(): boolean;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
