import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GuarddutyPublishingDestinationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_publishing_destination.html#destination_arn GuarddutyPublishingDestination#destination_arn}.
     *
     * @stability stable
     */
    readonly destinationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_publishing_destination.html#destination_type GuarddutyPublishingDestination#destination_type}.
     *
     * @stability stable
     */
    readonly destinationType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_publishing_destination.html#detector_id GuarddutyPublishingDestination#detector_id}.
     *
     * @stability stable
     */
    readonly detectorId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_publishing_destination.html#kms_key_arn GuarddutyPublishingDestination#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/guardduty_publishing_destination.html aws_guardduty_publishing_destination}.
 *
 * @stability stable
 */
export declare class GuarddutyPublishingDestination extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/guardduty_publishing_destination.html aws_guardduty_publishing_destination} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GuarddutyPublishingDestinationConfig);
    private _destinationArn;
    /**
     * @stability stable
     */
    get destinationArn(): string;
    /**
     * @stability stable
     */
    set destinationArn(value: string);
    /**
     * @stability stable
     */
    get destinationArnInput(): string;
    private _destinationType?;
    /**
     * @stability stable
     */
    get destinationType(): string;
    /**
     * @stability stable
     */
    set destinationType(value: string);
    /**
     * @stability stable
     */
    resetDestinationType(): void;
    /**
     * @stability stable
     */
    get destinationTypeInput(): string | undefined;
    private _detectorId;
    /**
     * @stability stable
     */
    get detectorId(): string;
    /**
     * @stability stable
     */
    set detectorId(value: string);
    /**
     * @stability stable
     */
    get detectorIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyArn;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
