import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface OpsworksUserProfileConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_user_profile.html#allow_self_management OpsworksUserProfile#allow_self_management}.
     *
     * @stability stable
     */
    readonly allowSelfManagement?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_user_profile.html#ssh_public_key OpsworksUserProfile#ssh_public_key}.
     *
     * @stability stable
     */
    readonly sshPublicKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_user_profile.html#ssh_username OpsworksUserProfile#ssh_username}.
     *
     * @stability stable
     */
    readonly sshUsername: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_user_profile.html#user_arn OpsworksUserProfile#user_arn}.
     *
     * @stability stable
     */
    readonly userArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_user_profile.html aws_opsworks_user_profile}.
 *
 * @stability stable
 */
export declare class OpsworksUserProfile extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_user_profile.html aws_opsworks_user_profile} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksUserProfileConfig);
    private _allowSelfManagement?;
    /**
     * @stability stable
     */
    get allowSelfManagement(): boolean;
    /**
     * @stability stable
     */
    set allowSelfManagement(value: boolean);
    /**
     * @stability stable
     */
    resetAllowSelfManagement(): void;
    /**
     * @stability stable
     */
    get allowSelfManagementInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _sshPublicKey?;
    /**
     * @stability stable
     */
    get sshPublicKey(): string;
    /**
     * @stability stable
     */
    set sshPublicKey(value: string);
    /**
     * @stability stable
     */
    resetSshPublicKey(): void;
    /**
     * @stability stable
     */
    get sshPublicKeyInput(): string | undefined;
    private _sshUsername;
    /**
     * @stability stable
     */
    get sshUsername(): string;
    /**
     * @stability stable
     */
    set sshUsername(value: string);
    /**
     * @stability stable
     */
    get sshUsernameInput(): string;
    private _userArn;
    /**
     * @stability stable
     */
    get userArn(): string;
    /**
     * @stability stable
     */
    set userArn(value: string);
    /**
     * @stability stable
     */
    get userArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
