import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface QuicksightUserConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#aws_account_id QuicksightUser#aws_account_id}.
     *
     * @stability stable
     */
    readonly awsAccountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#email QuicksightUser#email}.
     *
     * @stability stable
     */
    readonly email: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#iam_arn QuicksightUser#iam_arn}.
     *
     * @stability stable
     */
    readonly iamArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#identity_type QuicksightUser#identity_type}.
     *
     * @stability stable
     */
    readonly identityType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#namespace QuicksightUser#namespace}.
     *
     * @stability stable
     */
    readonly namespace?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#session_name QuicksightUser#session_name}.
     *
     * @stability stable
     */
    readonly sessionName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#user_name QuicksightUser#user_name}.
     *
     * @stability stable
     */
    readonly userName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#user_role QuicksightUser#user_role}.
     *
     * @stability stable
     */
    readonly userRole: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html aws_quicksight_user}.
 *
 * @stability stable
 */
export declare class QuicksightUser extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html aws_quicksight_user} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: QuicksightUserConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _awsAccountId?;
    /**
     * @stability stable
     */
    get awsAccountId(): string;
    /**
     * @stability stable
     */
    set awsAccountId(value: string);
    /**
     * @stability stable
     */
    resetAwsAccountId(): void;
    /**
     * @stability stable
     */
    get awsAccountIdInput(): string | undefined;
    private _email;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    set email(value: string);
    /**
     * @stability stable
     */
    get emailInput(): string;
    private _iamArn?;
    /**
     * @stability stable
     */
    get iamArn(): string;
    /**
     * @stability stable
     */
    set iamArn(value: string);
    /**
     * @stability stable
     */
    resetIamArn(): void;
    /**
     * @stability stable
     */
    get iamArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _identityType;
    /**
     * @stability stable
     */
    get identityType(): string;
    /**
     * @stability stable
     */
    set identityType(value: string);
    /**
     * @stability stable
     */
    get identityTypeInput(): string;
    private _namespace?;
    /**
     * @stability stable
     */
    get namespace(): string;
    /**
     * @stability stable
     */
    set namespace(value: string);
    /**
     * @stability stable
     */
    resetNamespace(): void;
    /**
     * @stability stable
     */
    get namespaceInput(): string | undefined;
    private _sessionName?;
    /**
     * @stability stable
     */
    get sessionName(): string;
    /**
     * @stability stable
     */
    set sessionName(value: string);
    /**
     * @stability stable
     */
    resetSessionName(): void;
    /**
     * @stability stable
     */
    get sessionNameInput(): string | undefined;
    private _userName?;
    /**
     * @stability stable
     */
    get userName(): string;
    /**
     * @stability stable
     */
    set userName(value: string);
    /**
     * @stability stable
     */
    resetUserName(): void;
    /**
     * @stability stable
     */
    get userNameInput(): string | undefined;
    private _userRole;
    /**
     * @stability stable
     */
    get userRole(): string;
    /**
     * @stability stable
     */
    set userRole(value: string);
    /**
     * @stability stable
     */
    get userRoleInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
