import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface RouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#carrier_gateway_id Route#carrier_gateway_id}.
     *
     * @stability stable
     */
    readonly carrierGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#destination_cidr_block Route#destination_cidr_block}.
     *
     * @stability stable
     */
    readonly destinationCidrBlock?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#destination_ipv6_cidr_block Route#destination_ipv6_cidr_block}.
     *
     * @stability stable
     */
    readonly destinationIpv6CidrBlock?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#destination_prefix_list_id Route#destination_prefix_list_id}.
     *
     * @stability stable
     */
    readonly destinationPrefixListId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#egress_only_gateway_id Route#egress_only_gateway_id}.
     *
     * @stability stable
     */
    readonly egressOnlyGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#gateway_id Route#gateway_id}.
     *
     * @stability stable
     */
    readonly gatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#instance_id Route#instance_id}.
     *
     * @stability stable
     */
    readonly instanceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#local_gateway_id Route#local_gateway_id}.
     *
     * @stability stable
     */
    readonly localGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#nat_gateway_id Route#nat_gateway_id}.
     *
     * @stability stable
     */
    readonly natGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#network_interface_id Route#network_interface_id}.
     *
     * @stability stable
     */
    readonly networkInterfaceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#route_table_id Route#route_table_id}.
     *
     * @stability stable
     */
    readonly routeTableId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#transit_gateway_id Route#transit_gateway_id}.
     *
     * @stability stable
     */
    readonly transitGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#vpc_endpoint_id Route#vpc_endpoint_id}.
     *
     * @stability stable
     */
    readonly vpcEndpointId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#vpc_peering_connection_id Route#vpc_peering_connection_id}.
     *
     * @stability stable
     */
    readonly vpcPeeringConnectionId?: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#timeouts Route#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: RouteTimeouts;
}
/**
 * @stability stable
 */
export interface RouteTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#create Route#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route.html#delete Route#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route.html aws_route}.
 *
 * @stability stable
 */
export declare class Route extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route.html aws_route} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RouteConfig);
    private _carrierGatewayId?;
    /**
     * @stability stable
     */
    get carrierGatewayId(): string;
    /**
     * @stability stable
     */
    set carrierGatewayId(value: string);
    /**
     * @stability stable
     */
    resetCarrierGatewayId(): void;
    /**
     * @stability stable
     */
    get carrierGatewayIdInput(): string | undefined;
    private _destinationCidrBlock?;
    /**
     * @stability stable
     */
    get destinationCidrBlock(): string;
    /**
     * @stability stable
     */
    set destinationCidrBlock(value: string);
    /**
     * @stability stable
     */
    resetDestinationCidrBlock(): void;
    /**
     * @stability stable
     */
    get destinationCidrBlockInput(): string | undefined;
    private _destinationIpv6CidrBlock?;
    /**
     * @stability stable
     */
    get destinationIpv6CidrBlock(): string;
    /**
     * @stability stable
     */
    set destinationIpv6CidrBlock(value: string);
    /**
     * @stability stable
     */
    resetDestinationIpv6CidrBlock(): void;
    /**
     * @stability stable
     */
    get destinationIpv6CidrBlockInput(): string | undefined;
    private _destinationPrefixListId?;
    /**
     * @stability stable
     */
    get destinationPrefixListId(): string;
    /**
     * @stability stable
     */
    set destinationPrefixListId(value: string);
    /**
     * @stability stable
     */
    resetDestinationPrefixListId(): void;
    /**
     * @stability stable
     */
    get destinationPrefixListIdInput(): string | undefined;
    private _egressOnlyGatewayId?;
    /**
     * @stability stable
     */
    get egressOnlyGatewayId(): string;
    /**
     * @stability stable
     */
    set egressOnlyGatewayId(value: string);
    /**
     * @stability stable
     */
    resetEgressOnlyGatewayId(): void;
    /**
     * @stability stable
     */
    get egressOnlyGatewayIdInput(): string | undefined;
    private _gatewayId?;
    /**
     * @stability stable
     */
    get gatewayId(): string;
    /**
     * @stability stable
     */
    set gatewayId(value: string);
    /**
     * @stability stable
     */
    resetGatewayId(): void;
    /**
     * @stability stable
     */
    get gatewayIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceId?;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    resetInstanceId(): void;
    /**
     * @stability stable
     */
    get instanceIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get instanceOwnerId(): string;
    private _localGatewayId?;
    /**
     * @stability stable
     */
    get localGatewayId(): string;
    /**
     * @stability stable
     */
    set localGatewayId(value: string);
    /**
     * @stability stable
     */
    resetLocalGatewayId(): void;
    /**
     * @stability stable
     */
    get localGatewayIdInput(): string | undefined;
    private _natGatewayId?;
    /**
     * @stability stable
     */
    get natGatewayId(): string;
    /**
     * @stability stable
     */
    set natGatewayId(value: string);
    /**
     * @stability stable
     */
    resetNatGatewayId(): void;
    /**
     * @stability stable
     */
    get natGatewayIdInput(): string | undefined;
    private _networkInterfaceId?;
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
    /**
     * @stability stable
     */
    set networkInterfaceId(value: string);
    /**
     * @stability stable
     */
    resetNetworkInterfaceId(): void;
    /**
     * @stability stable
     */
    get networkInterfaceIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get origin(): string;
    private _routeTableId;
    /**
     * @stability stable
     */
    get routeTableId(): string;
    /**
     * @stability stable
     */
    set routeTableId(value: string);
    /**
     * @stability stable
     */
    get routeTableIdInput(): string;
    /**
     * @stability stable
     */
    get state(): string;
    private _transitGatewayId?;
    /**
     * @stability stable
     */
    get transitGatewayId(): string;
    /**
     * @stability stable
     */
    set transitGatewayId(value: string);
    /**
     * @stability stable
     */
    resetTransitGatewayId(): void;
    /**
     * @stability stable
     */
    get transitGatewayIdInput(): string | undefined;
    private _vpcEndpointId?;
    /**
     * @stability stable
     */
    get vpcEndpointId(): string;
    /**
     * @stability stable
     */
    set vpcEndpointId(value: string);
    /**
     * @stability stable
     */
    resetVpcEndpointId(): void;
    /**
     * @stability stable
     */
    get vpcEndpointIdInput(): string | undefined;
    private _vpcPeeringConnectionId?;
    /**
     * @stability stable
     */
    get vpcPeeringConnectionId(): string;
    /**
     * @stability stable
     */
    set vpcPeeringConnectionId(value: string);
    /**
     * @stability stable
     */
    resetVpcPeeringConnectionId(): void;
    /**
     * @stability stable
     */
    get vpcPeeringConnectionIdInput(): string | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): RouteTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: RouteTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): RouteTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
