import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53VpcAssociationAuthorizationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_vpc_association_authorization.html#vpc_id Route53VpcAssociationAuthorization#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_vpc_association_authorization.html#vpc_region Route53VpcAssociationAuthorization#vpc_region}.
     *
     * @stability stable
     */
    readonly vpcRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_vpc_association_authorization.html#zone_id Route53VpcAssociationAuthorization#zone_id}.
     *
     * @stability stable
     */
    readonly zoneId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_vpc_association_authorization.html aws_route53_vpc_association_authorization}.
 *
 * @stability stable
 */
export declare class Route53VpcAssociationAuthorization extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_vpc_association_authorization.html aws_route53_vpc_association_authorization} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53VpcAssociationAuthorizationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _vpcId;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string;
    private _vpcRegion?;
    /**
     * @stability stable
     */
    get vpcRegion(): string;
    /**
     * @stability stable
     */
    set vpcRegion(value: string);
    /**
     * @stability stable
     */
    resetVpcRegion(): void;
    /**
     * @stability stable
     */
    get vpcRegionInput(): string | undefined;
    private _zoneId;
    /**
     * @stability stable
     */
    get zoneId(): string;
    /**
     * @stability stable
     */
    set zoneId(value: string);
    /**
     * @stability stable
     */
    get zoneIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
