import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SesReceiptRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#after SesReceiptRule#after}.
     *
     * @stability stable
     */
    readonly after?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#enabled SesReceiptRule#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#name SesReceiptRule#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#recipients SesReceiptRule#recipients}.
     *
     * @stability stable
     */
    readonly recipients?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#rule_set_name SesReceiptRule#rule_set_name}.
     *
     * @stability stable
     */
    readonly ruleSetName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#scan_enabled SesReceiptRule#scan_enabled}.
     *
     * @stability stable
     */
    readonly scanEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#tls_policy SesReceiptRule#tls_policy}.
     *
     * @stability stable
     */
    readonly tlsPolicy?: string;
    /**
     * add_header_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#add_header_action SesReceiptRule#add_header_action}
     *
     * @stability stable
     */
    readonly addHeaderAction?: SesReceiptRuleAddHeaderAction[];
    /**
     * bounce_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#bounce_action SesReceiptRule#bounce_action}
     *
     * @stability stable
     */
    readonly bounceAction?: SesReceiptRuleBounceAction[];
    /**
     * lambda_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#lambda_action SesReceiptRule#lambda_action}
     *
     * @stability stable
     */
    readonly lambdaAction?: SesReceiptRuleLambdaAction[];
    /**
     * s3_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#s3_action SesReceiptRule#s3_action}
     *
     * @stability stable
     */
    readonly s3Action?: SesReceiptRuleS3Action[];
    /**
     * sns_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#sns_action SesReceiptRule#sns_action}
     *
     * @stability stable
     */
    readonly snsAction?: SesReceiptRuleSnsAction[];
    /**
     * stop_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#stop_action SesReceiptRule#stop_action}
     *
     * @stability stable
     */
    readonly stopAction?: SesReceiptRuleStopAction[];
    /**
     * workmail_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#workmail_action SesReceiptRule#workmail_action}
     *
     * @stability stable
     */
    readonly workmailAction?: SesReceiptRuleWorkmailAction[];
}
/**
 * @stability stable
 */
export interface SesReceiptRuleAddHeaderAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#header_name SesReceiptRule#header_name}.
     *
     * @stability stable
     */
    readonly headerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#header_value SesReceiptRule#header_value}.
     *
     * @stability stable
     */
    readonly headerValue: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleBounceAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#message SesReceiptRule#message}.
     *
     * @stability stable
     */
    readonly message: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#sender SesReceiptRule#sender}.
     *
     * @stability stable
     */
    readonly sender: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#smtp_reply_code SesReceiptRule#smtp_reply_code}.
     *
     * @stability stable
     */
    readonly smtpReplyCode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#status_code SesReceiptRule#status_code}.
     *
     * @stability stable
     */
    readonly statusCode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#topic_arn SesReceiptRule#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn?: string;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleLambdaAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#function_arn SesReceiptRule#function_arn}.
     *
     * @stability stable
     */
    readonly functionArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#invocation_type SesReceiptRule#invocation_type}.
     *
     * @stability stable
     */
    readonly invocationType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#topic_arn SesReceiptRule#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn?: string;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleS3Action {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#bucket_name SesReceiptRule#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#kms_key_arn SesReceiptRule#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#object_key_prefix SesReceiptRule#object_key_prefix}.
     *
     * @stability stable
     */
    readonly objectKeyPrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#topic_arn SesReceiptRule#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn?: string;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleSnsAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#encoding SesReceiptRule#encoding}.
     *
     * @stability stable
     */
    readonly encoding?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#topic_arn SesReceiptRule#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn: string;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleStopAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#scope SesReceiptRule#scope}.
     *
     * @stability stable
     */
    readonly scope: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#topic_arn SesReceiptRule#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn?: string;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleWorkmailAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#organization_arn SesReceiptRule#organization_arn}.
     *
     * @stability stable
     */
    readonly organizationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html#topic_arn SesReceiptRule#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html aws_ses_receipt_rule}.
 *
 * @stability stable
 */
export declare class SesReceiptRule extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule.html aws_ses_receipt_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SesReceiptRuleConfig);
    private _after?;
    /**
     * @stability stable
     */
    get after(): string;
    /**
     * @stability stable
     */
    set after(value: string);
    /**
     * @stability stable
     */
    resetAfter(): void;
    /**
     * @stability stable
     */
    get afterInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _recipients?;
    /**
     * @stability stable
     */
    get recipients(): string[];
    /**
     * @stability stable
     */
    set recipients(value: string[]);
    /**
     * @stability stable
     */
    resetRecipients(): void;
    /**
     * @stability stable
     */
    get recipientsInput(): string[] | undefined;
    private _ruleSetName;
    /**
     * @stability stable
     */
    get ruleSetName(): string;
    /**
     * @stability stable
     */
    set ruleSetName(value: string);
    /**
     * @stability stable
     */
    get ruleSetNameInput(): string;
    private _scanEnabled?;
    /**
     * @stability stable
     */
    get scanEnabled(): boolean;
    /**
     * @stability stable
     */
    set scanEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetScanEnabled(): void;
    /**
     * @stability stable
     */
    get scanEnabledInput(): boolean | undefined;
    private _tlsPolicy?;
    /**
     * @stability stable
     */
    get tlsPolicy(): string;
    /**
     * @stability stable
     */
    set tlsPolicy(value: string);
    /**
     * @stability stable
     */
    resetTlsPolicy(): void;
    /**
     * @stability stable
     */
    get tlsPolicyInput(): string | undefined;
    private _addHeaderAction?;
    /**
     * @stability stable
     */
    get addHeaderAction(): SesReceiptRuleAddHeaderAction[];
    /**
     * @stability stable
     */
    set addHeaderAction(value: SesReceiptRuleAddHeaderAction[]);
    /**
     * @stability stable
     */
    resetAddHeaderAction(): void;
    /**
     * @stability stable
     */
    get addHeaderActionInput(): SesReceiptRuleAddHeaderAction[] | undefined;
    private _bounceAction?;
    /**
     * @stability stable
     */
    get bounceAction(): SesReceiptRuleBounceAction[];
    /**
     * @stability stable
     */
    set bounceAction(value: SesReceiptRuleBounceAction[]);
    /**
     * @stability stable
     */
    resetBounceAction(): void;
    /**
     * @stability stable
     */
    get bounceActionInput(): SesReceiptRuleBounceAction[] | undefined;
    private _lambdaAction?;
    /**
     * @stability stable
     */
    get lambdaAction(): SesReceiptRuleLambdaAction[];
    /**
     * @stability stable
     */
    set lambdaAction(value: SesReceiptRuleLambdaAction[]);
    /**
     * @stability stable
     */
    resetLambdaAction(): void;
    /**
     * @stability stable
     */
    get lambdaActionInput(): SesReceiptRuleLambdaAction[] | undefined;
    private _s3Action?;
    /**
     * @stability stable
     */
    get s3Action(): SesReceiptRuleS3Action[];
    /**
     * @stability stable
     */
    set s3Action(value: SesReceiptRuleS3Action[]);
    /**
     * @stability stable
     */
    resetS3Action(): void;
    /**
     * @stability stable
     */
    get s3ActionInput(): SesReceiptRuleS3Action[] | undefined;
    private _snsAction?;
    /**
     * @stability stable
     */
    get snsAction(): SesReceiptRuleSnsAction[];
    /**
     * @stability stable
     */
    set snsAction(value: SesReceiptRuleSnsAction[]);
    /**
     * @stability stable
     */
    resetSnsAction(): void;
    /**
     * @stability stable
     */
    get snsActionInput(): SesReceiptRuleSnsAction[] | undefined;
    private _stopAction?;
    /**
     * @stability stable
     */
    get stopAction(): SesReceiptRuleStopAction[];
    /**
     * @stability stable
     */
    set stopAction(value: SesReceiptRuleStopAction[]);
    /**
     * @stability stable
     */
    resetStopAction(): void;
    /**
     * @stability stable
     */
    get stopActionInput(): SesReceiptRuleStopAction[] | undefined;
    private _workmailAction?;
    /**
     * @stability stable
     */
    get workmailAction(): SesReceiptRuleWorkmailAction[];
    /**
     * @stability stable
     */
    set workmailAction(value: SesReceiptRuleWorkmailAction[]);
    /**
     * @stability stable
     */
    resetWorkmailAction(): void;
    /**
     * @stability stable
     */
    get workmailActionInput(): SesReceiptRuleWorkmailAction[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
