import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VpcEndpointServiceAllowedPrincipalConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_service_allowed_principal.html#principal_arn VpcEndpointServiceAllowedPrincipal#principal_arn}.
     *
     * @stability stable
     */
    readonly principalArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_service_allowed_principal.html#vpc_endpoint_service_id VpcEndpointServiceAllowedPrincipal#vpc_endpoint_service_id}.
     *
     * @stability stable
     */
    readonly vpcEndpointServiceId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_service_allowed_principal.html aws_vpc_endpoint_service_allowed_principal}.
 *
 * @stability stable
 */
export declare class VpcEndpointServiceAllowedPrincipal extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_service_allowed_principal.html aws_vpc_endpoint_service_allowed_principal} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcEndpointServiceAllowedPrincipalConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _principalArn;
    /**
     * @stability stable
     */
    get principalArn(): string;
    /**
     * @stability stable
     */
    set principalArn(value: string);
    /**
     * @stability stable
     */
    get principalArnInput(): string;
    private _vpcEndpointServiceId;
    /**
     * @stability stable
     */
    get vpcEndpointServiceId(): string;
    /**
     * @stability stable
     */
    set vpcEndpointServiceId(value: string);
    /**
     * @stability stable
     */
    get vpcEndpointServiceIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
